<template>
    <v-container class="fill-height" fluid>
        <v-row align="center" justify="center">
            <v-col cols="6" sm="8" md="4">
                <v-card :elevation="0">
                    <div class="text-h4 text-lg-h3 pa-7">QR Generator</div>
                    <v-text-field v-model="code" @input="Regen" label="Code"/>
                    <v-select :items="['Anchor','Tag']" v-model="type" @input="Regen"/>
                    <canvas id="mc" width="200px" height="200px">
                    </canvas>
                </v-card>
            </v-col>

        </v-row>

    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Vue} from 'vue-property-decorator';
    import QRCode from 'qrcode'

    const props = {};

    const Base = Vue.extend({props});

    @Component({props})
    export default class MainHome extends Base {
        code: string = "";
        type: string = "";

        async Regen() {
            const canvas = document.getElementById('mc') as HTMLCanvasElement;
            const ctx = canvas?.getContext("2d");
            const png = await QRCode.toDataURL(this.code);

            if (ctx != null) {
                ctx.clearRect(0, 0, 200, 200);
                ctx.fillStyle = "white";
                ctx.fillRect(0, 0, canvas.width, canvas.height);
                ctx.font = "20px Arial";
                ctx.fillStyle = "black";
                ctx.textBaseline = 'middle';
                ctx.textAlign = 'center';
                ctx.fillText(this.code, 100, 180);
                ctx.fillText(this.type, 100, 20);
                const img = new Image();
                img.onload = function () {
                    const w = img.width / 2;
                    const h = img.height / 2;
                    ctx.drawImage(img, 100 - w, 100 - h);
                }
                img.src = png;

            }

        }

    }
</script>
